

#include <stdio.h>

#define N 100000

void prefix(float* r, float* a, const int n) {
  r [0] = a [0] ;
  for(int i = 1 ; i < n ; i++)
    r [i] = r [i - 1] + a [i] ;
}

void checkPrefix(float* r, float* a, const int n) {

  if(r [0] != a [0])
    printf("checkPrefix: *** error detected !! ***\n") ;
  for(int i = 1 ; i < n ; i++)
    if(r [i] - r [i - 1] != a [i])
      printf("checkPrefix: *** error detected !! ***\n") ;
}

int main(int argv, char** argc) {
  float a [N], b [N] ;
  for(int i = 0 ; i < N ; i++)
    a [i] = 1.0 ;

  for(int j = 1 ; j < 1000 ; j++)
    prefix(b, a, N) ;

  checkPrefix(b, a, N) ;
}

